﻿Imports System.IO

Public Class Companies
    Private companies As New BinaryTree(Of String, Company)()

    Public Sub New(r As TextReader)
        ' Spaltenüberschriften auslesen
        Dim tokens = r.ReadLine().Split(New Char() {";"c})
        If tokens.Length <> 3 Then
            Throw New ArgumentException("More than 3 columns")
        End If

        Dim line As String = r.ReadLine()
        While line IsNot Nothing
            tokens = line.Split(New Char() {";"c})

            companies.Add(tokens(0), New Company() With {
                .Bezeichnung = tokens(0),
                .Branche = tokens(1),
                .Ort = tokens(2)
        })
            line = r.ReadLine()
        End While
        r.Close()
    End Sub

    Public Function Read(bezeichnung As String) As Company
        If companies.Contains(bezeichnung) = True Then
            Return companies(bezeichnung)
        End If
        Return Nothing
    End Function

End Class

Public Class Company

    Public Property Bezeichnung As String
    Public Property Branche As String
    Public Property Ort As String

    Public Overrides Function ToString() As String
        Return String.Format("Bezeichnung: {0}" & vbTab & "Branche: {1}" & vbTab & "Ort: {2}", Bezeichnung, Branche, Ort)
    End Function

End Class
