﻿Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary

Module Module1

    Sub Main(args As String())
        If (args.Length < 1) Then
            Throw New ArgumentException("Aufruf: MusicDB <folder>")
        End If

        ' Musikdateien einlesen...
        Dim Discs = New Discs(args(0))

        ' ...oder vom Cache
        Dim fileDb = Path.Combine(args(0), "musicDB.bin")
        If (Not File.Exists(fileDb)) Then
            Discs.Load()
        Else
            Using stream = File.OpenRead(fileDb)
                Dim deserializer = New BinaryFormatter()
                Discs = deserializer.Deserialize(stream)
            End Using
        End If

        Console.Write("DiscId eingeben, z.B. 2d0bde04: ")

        Dim discId = Console.ReadLine()
        While discId <> ""
            If String.IsNullOrEmpty(discId) = True Then
                Exit While
            End If

            Dim title = Discs.Read(discId)

            If (title Is Nothing) Then
                Console.WriteLine("Titel nicht gefunden!")
            Else
                Console.WriteLine($"{title}\n")
            End If
            discId = Console.ReadLine()
        End While

        Using stream = File.Create(fileDb)
            Dim serializer = New BinaryFormatter()
            serializer.Serialize(stream, Discs)
        End Using

    End Sub

End Module
