﻿Public Class PaintTools
    Public Shared Sub FloodFill(b As Bitmap, p As Point, newColor As Color)
        Dim oldColor As Color = b.GetPixel(p.X, p.Y)

        Dim stack As New Stack(Of Point)()

        stack.Push(p)

        While stack.Count <> 0
            p = stack.Pop()

            If b.GetPixel(p.X, p.Y).ToArgb() = oldColor.ToArgb() Then
                b.SetPixel(p.X, p.Y, newColor)

                ' 4-Neighbor
                stack.Push(New Point(p.X, p.Y + 1)) ' unten
                stack.Push(New Point(p.X + 1, p.Y)) ' rechts
                stack.Push(New Point(p.X, p.Y - 1)) ' oben
                stack.Push(New Point(p.X - 1, p.Y)) ' links vom Punkt
                ' bei 8-Neighbor zusätzlich...
                stack.Push(New Point(p.X + 1, p.Y + 1)) ' unten-rechts
                stack.Push(New Point(p.X - 1, p.Y + 1)) ' unten-links
                stack.Push(New Point(p.X + 1, p.Y - 1)) ' oben-rechts 
                stack.Push(New Point(p.X - 1, p.Y - 1)) ' oben-links
            End If
        End While
    End Sub

    ' bei großen zu füllenden Flächen Stapelüberlauf
    Public Shared Sub FloodFillRecursive(b As Bitmap, p As Point, newColor As Color, oldColor As Color)
        If b.GetPixel(p.X, p.Y).ToArgb() <> oldColor.ToArgb() Then
            Return
        End If

        b.SetPixel(p.X, p.Y, newColor)

        ' 4-Neighbor
        FloodFillRecursive(b, New Point(p.X, p.Y + 1), newColor, oldColor)
        ' unten
        FloodFillRecursive(b, New Point(p.X + 1, p.Y), newColor, oldColor)
        ' rechts
        FloodFillRecursive(b, New Point(p.X, p.Y - 1), newColor, oldColor)
        ' oben
        FloodFillRecursive(b, New Point(p.X - 1, p.Y), newColor, oldColor)
        ' links vom Punkt
    End Sub

End Class
