﻿Public Class Stack(Of T)
    Implements ICollection
    Private items As T()

    Public ReadOnly Property Count As Integer Implements ICollection.Count
        Get
            Return m_Count
        End Get
    End Property
    Private m_Count As Integer

    Public Sub New(length As Integer)
        items = New T(If(length = 0, 10, length) - 1) {}
    End Sub

    Public Sub New()
        Me.New(0)
    End Sub

    Public Sub Push(item As T)
        grow()

        items(Count) = item

        m_Count += 1
    End Sub

    Public Function Pop() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Dim item As T = items(Count - 1)
        items(Count - 1) = Nothing
        m_Count -= 1

        Return item
    End Function


    Public Function Peek() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Return items(Count - 1)
    End Function

    Public Sub Clear() Implements ICollection.Clear
        items = New T(10) {}
        m_Count = 0
    End Sub

    Private Sub grow()
        ' Überprüfen, ob noch Platz
        If items.Length >= Count + 1 Then
            Return
        End If

        ' Array-Kapazität verdoppeln
        Dim newLength As Integer = items.Length * 2

        Array.Resize(items, newLength)
    End Sub
End Class

