﻿Imports Queue

Public Class Queue(Of T)
    Implements ICollection

    Private items As T()

    Public Property Count As Integer Implements ICollection.Count
        Get
            Return _count
        End Get
        Private Set
            _count = Value
        End Set
    End Property
    Private _count As Integer

    Public Sub New(Optional length As Integer = 0)
        items = New T(If(length = 0, 10, length) - 1) {}
    End Sub

    Public Sub Enqueue(item As T)
        Grow()

        items(Count) = item

        _count += 1
    End Sub

    Public Function Peek() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Return items(0)
    End Function

    Public Function Dequeue() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Dim item As T = items(0)

        Array.Copy(items, 1, items, 0, Count - 1)

        items(Count - 1) = Nothing

        Count -= 1

        Return item
    End Function

    Public Sub Clear() Implements ICollection.Clear
        items = New T(10) {}
        _Count = 0
    End Sub

    Private Sub Grow()
        ' Überprüfen, ob noch Platz
        If items.Length >= Count + 1 Then
            Return
        End If

        ' Array-Kapazität verdoppeln
        Dim newLength As Integer = items.Length * 2

        Array.Resize(items, newLength)
    End Sub

End Class

