﻿Imports System.Runtime.CompilerServices

Module StringExtension

    ' Umsetzungstabelle für:   ABCDEFGHIJKLMNOPQRSTUVWXYZ
    Private Const map As String = "01230120022455012623010202"

    <Extension>
    Public Function Soundex(text As String) As String
        Return Soundex(text, 4)
    End Function

    <Extension>
    Public Function Soundex(text As String, maxLength As Integer) As String
        If String.IsNullOrEmpty(text) Then
            Return text
        End If

        text = text.ToUpper()

        Dim code As String = text(0).ToString()
        Dim last As Char = Char.MinValue

        For i As Integer = 1 To text.Length - 1
            Dim chr = text(i)

            Dim letter As Integer = Asc(chr) - Asc("A"c)
            If letter >= 0 AndAlso letter < map.Length Then
                If map(letter) <> last Then
                    code += map(letter)
                    last = map(letter)
                End If
            Else
                last = Char.MinValue
            End If
        Next

        code = code.Replace("0", "")
        ' Nicht zu berücksichtigende Zeichen entfernen
        If code.Length > maxLength Then
            code = code.Remove(maxLength)
        Else
            ' max. Länge
            code = code.PadRight(maxLength, "0"c)
        End If
        ' auf max. Länge auffüllen
        Return code
    End Function

End Module
