﻿Public Class ArrayList(Of T)

    Private items As T()

    Public Sub New(Optional length As Integer = 0)
        items = New T(If(length = 0, 4, length) - 1) {}
    End Sub

    Public Property Count() As Integer
        Get
            Return _count
        End Get
        Private Set
            _count = Value
        End Set
    End Property
    Private _count As Integer

    Public Sub Add(item As T)
        Grow()

        items(Count) = item

        Count += 1
    End Sub

    Private Sub Grow()
        ' Überprüfen, ob noch Platz
        If items.Length >= Count + 1 Then
            Return
        End If

        ' Array-Kapazität verdoppeln
        Dim newLength As Integer = items.Length * 2

        Array.Resize(items, newLength)
    End Sub

    Public Sub RemoveAt(index As Integer)
        If index < 0 Or index >= Count Then
            Throw New IndexOutOfRangeException()
        End If

        ' ein Eintrag nach links verschieben
        Array.Copy(items, index + 1, items, index, Count - (index + 1))

        Count -= 1
        items(Count) = Nothing
    End Sub

    Public Function Remove(item As T) As Boolean
        For i As Integer = 0 To Count - 1
            If items(i).Equals(item) Then
                RemoveAt(i)
                Return True
            End If
        Next

        Return False
    End Function

    Default Property item(ByVal index As Integer) As T
        Get
            Return items(index)
        End Get
        Set(ByVal Value As T)
            items(index) = Value
        End Set
    End Property

End Class
