﻿Public Class SortedArrayList(Of T As IComparable)
    Inherits ArrayList(Of T)

    Public Function BinarySearch(item As T) As Integer
        Dim lower = 0
        Dim upper = Count - 1

        While lower <= upper
            Dim mid As Integer = (lower + upper) / 2
            Dim c As Integer = item.CompareTo(Me(mid))

            If c = 0 Then
                Return mid
            ElseIf c > 0 Then
                lower = mid + 1 ' oben weitersuchen
            Else
                upper = mid - 1 ' unten weitersuchen
            End If
        End While
        Return Not lower
    End Function

    Public Function BinarySearchRecursive(item As T) As Integer
        Return Search(item, 0, Count - 1)
    End Function

    Private Function Search(item As T, lower As Integer, upper As Integer) As Integer
        If lower > upper Then
            Return Not lower
        End If

        Dim mid = (lower + upper) / 2

        Dim c = item.CompareTo(Me(mid))

        If c = 0 Then
            Return mid
        ElseIf c > 0 Then
            Return Search(item, mid + 1, upper) ' oben weitersuchen
        Else
            Return Search(item, lower, mid - 1) ' unten weitersuchen
        End If
    End Function
End Class