﻿Imports System.IO

Public Class Spelling
    Private list As SortedArrayList(Of String)

    Public NotInheritable Class Word
        Private word As String

        Public Property IsCorrect() As Boolean
        Public Property NearToWord() As String

        Sub New(word As String, isCorrect As Boolean, nearToWord As String)
            Me.word = word
            Me.NearToWord = nearToWord
            Me.IsCorrect = isCorrect
        End Sub

        Public Overrides Function ToString() As String
            Return word
        End Function
    End Class

    Public Sub New(reader As TextReader)
        list = New SortedArrayList(Of String)()

        Dim word As String = reader.ReadLine()

        While word IsNot Nothing
            If Not word.StartsWith("%") Then
                list.Add(word.ToLower())
            End If
            word = reader.ReadLine()
        End While

        reader.Close()
    End Sub

    Public Function CheckWord(word As String, ByRef nearToWord As String) As Boolean
        Dim index As Integer = list.BinarySearch(word.ToLower())

        If index < 0 Then
            nearToWord = If(Not index < list.Count, list(Not index), "")
            Return False
        End If
        Return True
    End Function

    Public Iterator Function CheckText(text As String) As IEnumerable
        Dim tokens = text.Split(New Char() {" "c, "."c, ","c, ":"c, ";"c, ControlChars.Cr,
    ControlChars.Lf}, StringSplitOptions.RemoveEmptyEntries)

        For Each token As String In tokens
            Dim nearToWord As String = ""
            Dim index As Integer = list.BinarySearch(token.ToLower())

            If index < 0 Then
                nearToWord = If(index < 0, list(Not index), "")
            End If

            Yield New Word(token, index >= 0, nearToWord)
        Next
    End Function

End Class
